//+------------------------------------------------------------------+
//|                                           LSMA WPR color nrp.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property  copyright "mladen"
#property  link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Yellow
#property indicator_color2 Green
#property indicator_color3 Green
#property indicator_color4 Red
#property indicator_color5 Red
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 2

//
//
//
//
//

double lsma[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];

//
//
//
//
//

extern int    WPRPeriod = 14;
extern double Level1    = -20.00;
extern double Level2    = -50.00;
extern double Level3    = -80.00;
extern color  LevelsColor = C'30,33,36';

double        min;
double        max;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,lsma);
   SetIndexBuffer(1,ExtMapBuffer2);
   SetIndexBuffer(2,ExtMapBuffer3);
   SetIndexBuffer(3,ExtMapBuffer4);
   SetIndexBuffer(4,ExtMapBuffer5);

   //
   //
   //
   //
   //

   for (int i = 0; i < indicator_buffers; i++)
   {
         SetIndexDrawBegin(i,WPRPeriod);
         SetIndexLabel(i,"LSMA WPR color");
   }         
   SetLevelValue(0,Level1);
   SetLevelValue(1,Level2);
   SetLevelValue(2,Level3);
      IndicatorShortName("LSMA WPR ("+WPRPeriod+")");
   return(0);
}


int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{ 
   int      counted_bars=IndicatorCounted();
   int      limit,i;
   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   //
   //
   //
   //
   //
   
   if (lsma[limit] > lsma[limit+1]) CleanPoint(limit,ExtMapBuffer2,ExtMapBuffer3);
   if (lsma[limit] < lsma[limit+1]) CleanPoint(limit,ExtMapBuffer4,ExtMapBuffer5);

   for(i = limit; i >= 0; i--)
   {  
      lsma[i] = iLSMA(NULL,0,WPRPeriod,i);
      min     = MathMin(lsma[i],min);
      max     = MathMax(lsma[i],max);
         ExtMapBuffer2[i] = EMPTY_VALUE;
         ExtMapBuffer3[i] = EMPTY_VALUE;
         ExtMapBuffer4[i] = EMPTY_VALUE;
         ExtMapBuffer5[i] = EMPTY_VALUE;
      
         //
         //
         //
         //
         //
            
         if (lsma[i] > lsma[i+1]) PlotPoint(i,ExtMapBuffer2,ExtMapBuffer3,lsma);
         if (lsma[i] < lsma[i+1]) PlotPoint(i,ExtMapBuffer4,ExtMapBuffer5,lsma);
   }
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iLSMA(string symbol,int TimeFrame,int period,int shift)
{
   double lengthvar = (period + 1.0)/3.0;
   double sum       = 0.0;
   double res       = 0.0;

   if (symbol=="0") symbol=Symbol();

   //
   //
   //
   //
   //
   
   for(int i = period; i >= 1 ; i--)
      sum += (i-lengthvar)*iWPR(symbol,TimeFrame,period,shift+period-i);
      res  = sum*6/(period*(period+1.0));
   return(res);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}